/*
 * Developed by Hillstone Software. http://www.hillstone-software.com
 */
#ifndef _HS_ARP_IF_H
#define _HS_ARP_IF_H

extern void put_word(unsigned char *pkt, unsigned short val);
extern void get_word(unsigned char *pkt, unsigned short *val);
extern void put_dword(unsigned char *pkt, unsigned long val);
extern void get_dword(unsigned char *pkt, unsigned long *val);

typedef void hsarp_drv_tx_fn_t(unsigned char *pkt, int len);
typedef void hsarp_log_fn_t(char *str);

typedef struct
{
	unsigned long local_ip;		// local ip address
} hs_arp_params_t;

/* Initialise ARP module */
extern void HsArpInit(unsigned long local_ip, unsigned char *local_eth, hsarp_drv_tx_fn_t *drv_tx, hsarp_log_fn_t *log_fn);

/*
 * Set ARP parameters at run-time
 */
extern void HsArpSetParams(hs_arp_params_t *pPar);

/*
 * Resolve IP address to ethernet address.
 * If resolved returns TRUE, otherwise returns FALSE
 * and will send ARP request. When ARP response is received
 * that resolves this IP address, HsArp call a function is HsIp 
 * to indicate that resolved ARP address of this IP. 
 * If a packet is buffered at upper layer it should now be re-transmitted 
 */
extern int HsArpResolveAddress(unsigned long dest_ip, unsigned char *eth_addr);

/* process received ARP packet */
extern void HsArpReceivedEthPacket(unsigned char *pkt, int len);

#endif /* _HS_ARP_IF_H */
