#include "tcpudptest.h"

TCHAR			szWindowClass[]		= " ";
HINSTANCE		hInst;
TCHAR			szTitle[] = "HsTCPIPv4 test application";

HWND			hwnd_main;
HWND			dlg_main;
HBRUSH			hbrush1				= NULL;

static int		num_events			= 0;

char *m_title = NULL;
char *m_prmt = NULL;
char *m_err = NULL;
char *m_hdr = "Error";

BOOL bThreadClosed = FALSE;
DWORD				ThreadId;			// thread id
HANDLE 				hThread;			// thread handle

DWORD				TspThreadId;

long				local_inbox_handles[2] = {0, 1};
long				tsp_inbox_handes[2] = {0, 0};

static TIMECAPS		timecaps;

static timerbock_t	timers[MAXTIMERS] = {0};

static app_session_t session_list[MAXSESSIONS] = {0};

long listen_sock_han = 0;

// pcap local interface device list
pcap_if_t *alldevs = NULL;
pcap_t *adhandle = NULL;


char *proto[] = {
	"TCP",
	"UDP",
	0,
};

char *stype[] = {
	"Client",
	"Server",
	0,
};

char *sstate[] = 
{
	"Closed",
	"Trying",
	"Listen",
	"Up",
};

static unsigned char source_ipaddr[17] = {0};
static unsigned char gw_ipaddr[17] = {0};
static unsigned char mask[17] = {0};
static unsigned char dns_ipaddr[17] = "0.0.0.0";

unsigned char testmsg1[] = "**************test message1";

// allocate session
static app_session_t *alloc_session(void)
{
	int i;

	for (i=0; i<MAXSESSIONS; i++)
	{
		if (!session_list[i].allocated)
		{
			memset(&session_list[i], 0, sizeof(app_session_t));
			session_list[i].allocated = TRUE;
			return &session_list[i];
		}
	}

	return NULL;
}

// free session
static void free_session(app_session_t *p)
{
	p->allocated = FALSE;
}

// allocate timer
static timerbock_t *alloc_timer(void)
{
	int i;

	for (i=0; i<MAXTIMERS; i++)
	{
		if (!timers[i].allocated)
		{
			timers[i].allocated = TRUE;
			return &timers[i];
		}
	}

	return NULL;
}

// free timer
static void free_timer(timerbock_t *p)
{
	p->allocated = FALSE;
}

HWND NewDialogWin(HINSTANCE hInst, HWND parent, DLGPROC proc, int dlg_id)
{
	HWND	handle;

	handle = CreateDialog(hInst, (LPCTSTR)dlg_id, parent, proc);

	ShowWindow	(handle, SW_SHOWDEFAULT);
    UpdateWindow(handle);

	return	handle;
}

// initialize combo box control
void InitComboControl(HWND wnd, char **buf, int dglid, int default_ind)
{
	int i = 0;

	while (buf[i])
	{
		SendDlgItemMessage(wnd, dglid, CB_ADDSTRING, 0, (long)buf[i++]);
	}

	SendMessage(GetDlgItem(wnd, dglid), CB_SETCURSEL, default_ind, 0);
}

ATOM BlRegisterClass(HINSTANCE	hInstance,
					UINT		style,
					WNDPROC		proc,
					int			cursor_id,
					HBRUSH		bkg_brush,
					LPCTSTR		lpszClassName,
					int			icon_id,
					int			menu_id)
{
	WNDCLASSEX	wcex;

	wcex.cbSize			= sizeof(WNDCLASSEX); 

	wcex.style			= style;
	wcex.lpfnWndProc	= proc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= 0;

	wcex.hCursor		= 0;
	if (cursor_id)
	{
		wcex.hCursor	= LoadCursor(0, (const char *)cursor_id);
	}

	wcex.hbrBackground	= bkg_brush;
	wcex.lpszMenuName	= (LPCSTR)menu_id;
	wcex.lpszClassName	= lpszClassName;

	wcex.hIconSm		= 0; 
	if (icon_id)
	{
		wcex.hIcon		= LoadIcon(hInstance, (LPCTSTR)icon_id);
	}
	return RegisterClassEx(&wcex);
}

static void write_event(char *str)
{
	LVITEM 		item = {0};
  	unsigned char s[80];
  	int 		index;
  	int			*p;

	HWND lvhan = GetDlgItem(dlg_main, IDC_LIST_EV);

	memset(&item, 0, sizeof (LVITEM));

	item.mask = LVIF_TEXT | LVIF_PARAM;

	memset(s, 0, sizeof s);
	sprintf(s, "%s",str);
	item.pszText = s;

	item.lParam = (LPARAM)1;
	item.iItem = 0xffff;
	index = ListView_InsertItem(lvhan, (LPLVITEM)&item);

	ListView_EnsureVisible(lvhan, index, 0);

	p = &num_events;

	if (*p < MAX_EVENTS)
	{
		(*p)++;
	}
	else
	{
		ListView_DeleteItem(lvhan, 0);
	}	
}

BOOL InitListView (HWND hwndListView, TCHAR szString[10][40], int clen[10], int num, int show_grid)
{
	int index;                      
	LV_COLUMN lvColumn;    
	DWORD dwExStyle;
	
	int i = 0;

  	// Initialize the columns in the list view.
  	lvColumn.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
  	lvColumn.fmt = LVCFMT_LEFT;

  	// Insert the five columns in the list view.
  	for (index = 0; index < num; index++)
  	{
    	lvColumn.pszText = szString[index];
		lvColumn.cx = clen[index];
    	ListView_InsertColumn (hwndListView, index, &lvColumn);
  	}

	dwExStyle = LVS_EX_FULLROWSELECT;
	if (show_grid)
		dwExStyle |= LVS_EX_GRIDLINES;

	ListView_SetExtendedListViewStyle(hwndListView, dwExStyle);

  	return TRUE;
}

// Add session
static void LvAddSession(app_session_t *p)
{
	LVITEM 		item = {0};
  	unsigned char s[80];
  	int 		index;

	HWND lvhan = GetDlgItem(dlg_main, IDC_LIST_SESSION);

	memset(&item, 0, sizeof (LVITEM));

	item.mask = LVIF_TEXT | LVIF_PARAM;	
	
	sprintf(s, "%s:%u", source_ipaddr, p->local_port);
	item.pszText = s;

	item.lParam = (LPARAM)p;
	item.iItem = 0xffff;
	index = ListView_InsertItem(lvhan, (LPLVITEM)&item);

	sprintf(s, "%s:%u", p->remote_ip_str, p->remote_port);	
	ListView_SetItemText(lvhan, index, 1, s);

	ListView_SetItemText(lvhan, index, 2, proto[p->protocol]);
	ListView_SetItemText(lvhan, index, 3, sstate[p->state]);
}

// get group index in groups listview corresponding to group id
static int get_session_index(app_session_t *p)
{
	HWND lvhan = GetDlgItem(dlg_main, IDC_LIST_SESSION);
	int i;
	LVFINDINFO lvfi = {0};

	lvfi.flags = LVFI_PARAM;
	lvfi.lParam = (LPARAM)p;
	i = (int)ListView_FindItem(lvhan, -1, &lvfi);
	
	return i;
}

// Add session
static void LvSetSession(app_session_t *p)
{
	LVITEM 		item = {0};
  	unsigned char s[80];
  	int 		index;

	HWND lvhan = GetDlgItem(dlg_main, IDC_LIST_SESSION);

	index = get_session_index(p);
	
	sprintf(s, "%s:%u", source_ipaddr, p->local_port);
	ListView_SetItemText(lvhan, index, 0, s);

	sprintf(s, "%s:%u", p->remote_ip_str, p->remote_port);	
	ListView_SetItemText(lvhan, index, 1, s);

	ListView_SetItemText(lvhan, index, 2, proto[p->protocol]);
	ListView_SetItemText(lvhan, index, 3, sstate[p->state]);
}

static void LvRemSession(app_session_t *p)
{
	int 		index;
	HWND lvhan = GetDlgItem(dlg_main, IDC_LIST_SESSION);

	index = get_session_index(p);

	ListView_DeleteItem(lvhan, index);
}

static app_session_t *ListViewGetSelectedSession(void)
{
	LRESULT iSelect;
	LVITEM	item = {0};
	app_session_t *p;

	iSelect=SendMessage(GetDlgItem(dlg_main, IDC_LIST_SESSION), LVM_GETNEXTITEM, -1, LVNI_FOCUSED);
	if (iSelect == -1)
	{
		return NULL;
	}
			
	item.mask = LVIF_PARAM;
	item.iItem = (int)iSelect;
	ListView_GetItem(GetDlgItem(dlg_main, IDC_LIST_SESSION), &item);
	p = (app_session_t *)item.lParam;

	return p;
}

static unsigned char hex2byte(unsigned char *buf)
{
	unsigned char hex[] = "0123456789ABCDEF";
	unsigned char b = 0;
    unsigned char b1, b2;
	int i;

    b1 = toupper(buf[0]);
    b2 = toupper(buf[1]);

	for (i = 0; i<16; i++)
	{
		if (b1 == hex[i])
		{
			b &= 0x0f;
			b = (unsigned char)((i << 4) & 0xf0);
			break;
		}
	}

	for (i = 0; i<16; i++)
	{
		if (b2 == hex[i])
		{
			b &= 0xf0;
			b |= (unsigned char)(i & 0x0f);
			break;
		}
	}
	
	return b;
}

// Convert ascii hex ethernet address in the form 00:00:00:00:00:00 to binary 6 byte buffer
static void convert_hex_ethaddr_to_binary(unsigned char *hexbuf, unsigned char *binbuf)
{
	int i, n, maxlen, done;

	maxlen = 17;

	if (strlen(hexbuf) != 17)
		return;

	done = FALSE;
	i = 0; n = 0;
	while (!done)
	{
		binbuf[i] = hex2byte(&hexbuf[n]);

		i++;
		n += 3;

		if (i == 6) 
			done = TRUE;
	}
}

// multimedia timer callback
void CALLBACK mmTimeProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	PostMessage(hwnd_main, WM_APP_TIMER, 0, (LPARAM)dwUser);
}

// Process timer message
static void process_timer(LPARAM lParam)
{
	timerbock_t *pTmrBlk;

	pTmrBlk = (timerbock_t *)lParam;

	if (!pTmrBlk) return;

	if (!pTmrBlk->allocated)
		return;

	if (!pTmrBlk->enabled)
		return;

	pTmrBlk->cb(pTmrBlk->arg);

	free_timer(pTmrBlk);
}

// start timer function
static long sock_timer_start(unsigned long timeout_ms, void *arg, hs_sock_timer_cb_t *cb)
{
	MMRESULT res;
	timerbock_t *pTmrBlk;

	pTmrBlk = (timerbock_t *)alloc_timer();
	if (!pTmrBlk) return 0;

	pTmrBlk->arg = arg;
	pTmrBlk->cb = cb;
	pTmrBlk->enabled = TRUE;

	res = timeSetEvent((UINT)timeout_ms, timecaps.wPeriodMin, mmTimeProc, (DWORD)pTmrBlk, TIME_ONESHOT);
	if (res == 0) 
	{	
		free_timer(pTmrBlk);
		return 0;
	}

	pTmrBlk->timer_id = (UINT)res;

	return (long)pTmrBlk;
}

// stop timer function
static void sock_timer_stop(long timer_han)
{
	timerbock_t *pTmrBlk;

	pTmrBlk = (timerbock_t *) timer_han;

	if (!pTmrBlk) return;

	if (!pTmrBlk->enabled) return;

	timeKillEvent(pTmrBlk->timer_id);
	pTmrBlk->enabled = FALSE;
}

// transmit over physical layer (ethernet)
static void sock_drv_tx_fn(unsigned char *pkt, int len)
{
	unsigned char str[2048];

	if (!adhandle) return;

	/* Send down the packet */
	if (pcap_sendpacket(adhandle,	// Adapter
		pkt,						// buffer with the packet
		len							// size
		) != 0)
	{
		sprintf(str,"Error sending the packet: ", pcap_geterr(adhandle));
		return;
	}	
}

// Socket event callback
long sock_event_fn_udp(long user_handle, int ev, long arg1, long arg2, long arg3, long arg4)
{
	unsigned char *buf;
	unsigned char locbuf[2048] = {0};
	unsigned char str[80];
	int len;

	switch (ev)
	{
	case HS_SOCK_EV_DATA:
		buf = (unsigned char *)arg1;
		len = (int)arg2;

		sprintf(str, "Socket data received len=%u", len);
		write_event(str);

		if (len >= sizeof(locbuf))
			break;

		memcpy(locbuf, buf, len);

		SetDlgItemText(dlg_main, IDC_EDIT_TEXT, locbuf);
		break;
	}

	return 0;	
}

// Socket event callback
long sock_event_fn_tcp(long user_handle, int ev, long arg1, long arg2, long arg3, long arg4)
{
	app_session_t *pSession;
	unsigned long remote_ip;
	char str[256];
	int len;
	unsigned char *pBuf;
	unsigned char locbuf[4096];

	
	switch (ev)
	{
	// incoming TCP connection accepted
	case HS_SOCK_EV_ACCEPTED:
		pSession = alloc_session();
		if (!pSession) return 0;

		pSession->sock_han = arg1;
		pSession->protocol = PROTOCOL_SELECTION_TCP;
		pSession->state = sStateConnected;
		pSession->local_port = (unsigned short int)arg4;

		remote_ip = arg3;

		HsSockInetNtoa(remote_ip, pSession->remote_ip_str);

		pSession->remote_port = (unsigned short)arg2;
				
		LvAddSession(pSession);
		
		write_event("TCP session connected");
		
		return (long)pSession;

	case HS_SOCK_EV_CLOSED:
		pSession = (app_session_t *)user_handle;
		if (!pSession) 
			break;

		if (!pSession->allocated)
			break;

		LvRemSession(pSession);

		free_session(pSession);

		write_event("TCP session closed");
		break;

	case HS_SOCK_EV_CONNECTED:
		pSession = (app_session_t *)user_handle;
		if (!pSession) 
			break;

		if (!pSession->allocated)
			break;

		pSession->state = sStateConnected;
		LvSetSession(pSession);

		write_event("TCP session connected");
		break;

	case HS_SOCK_EV_DATA:
		pSession = (app_session_t *)user_handle;
		if (!pSession) 
			break;

		if (!pSession->allocated)
			break;

		pBuf = (unsigned char *)arg1;
		len = (int)arg2;

		sprintf(str, "TCP Socket data received len=%u", len);
		write_event(str);

		if (len < sizeof(locbuf))
		{
			memcpy(locbuf, pBuf, len);
			locbuf[len] = 0;
			SetDlgItemText(dlg_main, IDC_EDIT_TEXT, locbuf);
		}
		break;
	}

	return 0;
}

// Add new session
static void add_session(HWND hDlg)
{
	BOOL bTranslated;
	app_session_t *pSession;
	unsigned long addr;
	unsigned char str[128];
	int rc;

	pSession = alloc_session();
	if (!pSession)
	{
		write_event("Cannot add new session, max number of sessions reached.");
		return;
	}

	pSession->protocol = (int)SendDlgItemMessage(hDlg, IDC_COMBO_PROTO, CB_GETCURSEL, 0, 0);
	if (pSession->protocol == CB_ERR) 
	{
		free_session(pSession);
		return;
	}

	pSession->type = (int)SendDlgItemMessage(hDlg, IDC_COMBO_TYPE, CB_GETCURSEL, 0, 0);
	if (pSession->type == CB_ERR) 
	{
		free_session(pSession);
		return;
	}

	GetDlgItemText(hDlg, IDC_EDIT_REMH, pSession->remote_ip_str, sizeof(pSession->remote_ip_str)-1);

	pSession->local_port = (unsigned short int)GetDlgItemInt(hDlg, IDC_EDIT_LOCP, &bTranslated, FALSE);
	pSession->remote_port = (unsigned short int)GetDlgItemInt(hDlg, IDC_EDIT_REMP, &bTranslated, FALSE);

	if (pSession->protocol == PROTOCOL_SELECTION_UDP)
	{
		pSession->state = sStateConnected;
	
		if (!HsSockInetAddr(pSession->remote_ip_str, &addr))
		{
			free_session(pSession);
			write_event("Cannot add new session, invalid remote ip address.");
			return;
		}

		pSession->dest_ip = addr;
		
		rc = HsSockUdpOpen((long)pSession, sock_event_fn_udp, pSession->local_port, &pSession->sock_han);
		if (rc != HS_SOCK_RC_OK)
		{
			sprintf(str, "HsSockUdpOpen failed rc=%s", HsSockGetRcString(rc));
			write_event(str);
			free_session(pSession);
			return;
		}

		LvAddSession(pSession);

		write_event("HsSockUdpOpen OK.");
		
	}
	else if (pSession->protocol == PROTOCOL_SELECTION_TCP)
	{
		pSession->state = sStateConnecting;

		if (!HsSockInetAddr(pSession->remote_ip_str, &addr))
		{
			free_session(pSession);
			write_event("Cannot add new session, invalid remote ip address.");
			return;
		}

		pSession->dest_ip = addr;

		rc = HsSockTcpConnect((long)pSession, sock_event_fn_tcp, pSession->remote_ip_str, 
			pSession->remote_port, &pSession->sock_han);

		if (rc != HS_SOCK_RC_OK)
		{
			sprintf(str, "HsSockTcpConnect failed rc=%s", HsSockGetRcString(rc));
			write_event(str);
			free_session(pSession);
			return;
		}
		
		LvAddSession(pSession);

		write_event("HsSockTcpConnect initiated OK.");
	}
}

void start_listen(HWND hDlg)
{
	int protocol;
	int type;
	unsigned char remote_ip_str[17] = {0};
	unsigned short local_port;
	unsigned short remote_port;
	BOOL bTranslated;
	app_session_t *pSession;
	unsigned long addr;
	int rc;
	char str[256];
	
	protocol = (int)SendDlgItemMessage(hDlg, IDC_COMBO_PROTO, CB_GETCURSEL, 0, 0);
	if (protocol == CB_ERR) 
		return;

	type = (int)SendDlgItemMessage(hDlg, IDC_COMBO_TYPE, CB_GETCURSEL, 0, 0);
	if (type == CB_ERR) 
		return;

	GetDlgItemText(hDlg, IDC_EDIT_REMH, remote_ip_str, sizeof (remote_ip_str)-1);

	local_port = (unsigned short int)GetDlgItemInt(hDlg, IDC_EDIT_LOCP, &bTranslated, FALSE);
	remote_port = (unsigned short int)GetDlgItemInt(hDlg, IDC_EDIT_REMP, &bTranslated, FALSE);

	if (protocol == PROTOCOL_SELECTION_UDP)
	{
		pSession = alloc_session();
		if (!pSession)
		{
			write_event("Cannot add new session, max number of sessions reached.");
			return;
		}
	
		pSession->state = sStateConnected;
		pSession->protocol = protocol;
	
		if (!HsSockInetAddr(remote_ip_str, &addr))
		{
			free_session(pSession);
			write_event("Cannot add new session, invalid remote ip address.");
			return;
		}

		pSession->dest_ip = addr;
		pSession->local_port = local_port;
		pSession->remote_port = remote_port;
		
		rc = HsSockUdpOpen((long)pSession, sock_event_fn_udp, pSession->local_port, &pSession->sock_han);
		if (rc != HS_SOCK_RC_OK)
		{
			sprintf(str, "HsSockUdpOpen failed rc=%s", HsSockGetRcString(rc));
			write_event(str);
			free_session(pSession);
			return;
		}

		LvAddSession(pSession);

		write_event("HsSockUdpOpen OK.");		
	}
	else if (protocol == PROTOCOL_SELECTION_TCP)
	{
		rc = HsSockTcpListen(local_port, (long)local_port, sock_event_fn_tcp, &listen_sock_han);
		if (rc != HS_SOCK_RC_OK)
		{
			sprintf(str, "HsSockTcpListen failed rc=%s", HsSockGetRcString(rc));
			write_event(str);
			return;
		}

		sprintf(str, "HsSockTcpListen OK. Listening on local port %u", local_port);
		write_event(str);
	}
}

// Send data
static void send_buffer(HWND hDlg)
{
	app_session_t *pSession;
	unsigned char str[128];
	int rc, txed_len;

	unsigned char buffer[512] = {0};
	unsigned short int len;

	pSession = ListViewGetSelectedSession();
	if (!pSession)
	{
		write_event("No session is selected, cannot send");
		return;
	}

	GetDlgItemText(hDlg, IDC_EDIT_TEXT, buffer, sizeof(buffer));
	len = (unsigned short int)strlen(buffer);


	if (pSession->protocol == PROTOCOL_SELECTION_TCP)
	{
		rc = HsSockTcpSend(pSession->sock_han, buffer, len, &txed_len);
		
		sprintf(str, "HsSockTcpSend rc=%s", HsSockGetRcString(rc));
		write_event(str);		
	}
	else if (pSession->protocol == PROTOCOL_SELECTION_UDP)
	{

		rc = HsSockUdpSendto(pSession->sock_han, pSession->dest_ip, pSession->remote_port, buffer, len);
		
		sprintf(str, "HsSockUdpSendto rc=%s", HsSockGetRcString(rc));
		write_event(str);
	}
}

static void close_session(HWND hDlg)
{
	app_session_t *pSession;

	pSession = ListViewGetSelectedSession();
	if (!pSession)
	{
		write_event("No session is selected, cannot send");
		return;
	}

	HsSockClose(pSession->sock_han);

	write_event("Session closed by user");

	LvRemSession(pSession);
}

// callback used by HSTCP to get number of millisecond ticks since bootup
// Used for generating pseudo random initial sequence number
// if callback pointer not initialized, HSTCP will use default 
// pseudo random number generator to produce initial sequence numbers
static unsigned long hs_sock_get_ticks(void)
{
	return (unsigned long)GetTickCount();
}

// Callback used by the stack whenever it needs a random 32 bit number
static unsigned long hs_sock_get_rand32(void)
{
	return (unsigned long)rand();
}

// global socket events
static long hs_sock_global_event(long user_handle, int ev, long arg1, long arg2, long arg3, long arg4)
{
	hs_dhcp_update_t *p;
	char str[17];

	switch (ev)
	{

	// have been aquired by HSDHCP
	case HS_SOCK_EV_DHCP_UPDATE:
		p = (hs_dhcp_update_t *)arg1;
		if (!p) return 0;

		memset(str, 0, sizeof(str));
		HsSockInetNtoa(p->local_ip, str);
		SetDlgItemText(dlg_main, IDC_IPADDRESS1, str);
		break;
	}

	return 0;
}

/*
 * Main dialog handler
 */
LRESULT CALLBACK DlgWin(HWND hDlg, UINT message, 
						  WPARAM wParam, LPARAM lParam)
{
	LRESULT result = FALSE;
	int rc, i;
	char str[512];
	char errbuf[PCAP_ERRBUF_SIZE];

	TCHAR szStringEvlog[10][40] = {TEXT(" "),};
	int clen_evlog[10] = {500};
	
	TCHAR szStringSess[10][40] = {TEXT("Src"),TEXT("Dst"),TEXT("Proto"), TEXT("Status")};
	int clen_sess[10] = {120, 120, 40, 60};

	unsigned char ascii_hex_eth[19] = {0};
	unsigned char ethaddr[6];

	int inum;

	pcap_if_t *d;

	hssock_init_t sockinit = {0};
	
	switch (message)
	{
	case WM_INITDIALOG:
		dlg_main = hDlg;

		//SetDlgItemText(hDlg, IDC_IPADDRESS1, "192.168.1.51");
		SetDlgItemText(hDlg, IDC_IPADDRESS1, "10.1.10.211");
		SetDlgItemText(hDlg, IDC_EDIT_MAC, "00:1E:68:A4:FB:15");
		//SetDlgItemText(hDlg, IDC_EDIT_REMH, "192.168.1.34");
		SetDlgItemText(hDlg, IDC_EDIT_REMH, "10.1.10.210");
		SetDlgItemText(hDlg, IDC_EDIT_LOCP, "2000");
		SetDlgItemText(hDlg, IDC_EDIT_REMP, "2001");
		SetDlgItemText(hDlg, IDC_EDIT_TEXT, "test buffer");

		InitComboControl(hDlg, proto, IDC_COMBO_PROTO, 0);
		InitComboControl(hDlg, stype, IDC_COMBO_TYPE, 0);

		InitListView(GetDlgItem(hDlg, IDC_LIST_SESSION), szStringSess, clen_sess, 4, TRUE);
		InitListView(GetDlgItem(hDlg, IDC_LIST_EV), szStringEvlog, clen_evlog, 1, FALSE);

		CheckDlgButton(hDlg, IDC_CHECK_DHCP, BST_CHECKED);
		EnableWindow(GetDlgItem(hDlg, IDC_IPADDRESS1), FALSE);
		
		/* Retrieve the device list */
		if(pcap_findalldevs(&alldevs, errbuf) == -1)
		{
			sprintf(str, "Error in pcap_findalldevs: %s", errbuf);
			write_event(str);
			return TRUE;
		}

		i = 0;
		for(d=alldevs; d; d=d->next)
		{			
			sprintf(str, "[%d] %s", ++i, d->description);
			SendDlgItemMessage(hDlg, IDC_COMBO_ETHIF, CB_ADDSTRING, 0, (long)str);			
		}	

		SendMessage(GetDlgItem(hDlg, IDC_COMBO_ETHIF), CB_SETCURSEL, 0, 0);

		srand( (unsigned)time( NULL ) );
		return TRUE;

	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDC_CHECK_DHCP:
			if (IsDlgButtonChecked(hDlg, IDC_CHECK_DHCP) == BST_CHECKED)
				EnableWindow(GetDlgItem(hDlg, IDC_IPADDRESS1), TRUE);
			else
				EnableWindow(GetDlgItem(hDlg, IDC_IPADDRESS1), FALSE);
			break;
		
		// initialize
		case IDC_BUTTON_INIT:
			if (adhandle)
				pcap_close(adhandle);
			
			inum = (int)SendDlgItemMessage(hDlg, IDC_COMBO_ETHIF, CB_GETCURSEL, 0, 0);
			if (inum == CB_ERR)
			{
				write_event("Local adapter not selected from list");
				break;
			}

			GetDlgItemText(hDlg, IDC_IPADDRESS1, source_ipaddr, sizeof (source_ipaddr) - 1);
			GetDlgItemText(hDlg, IDC_EDIT_MAC, ascii_hex_eth, sizeof (ascii_hex_eth) - 1);

			convert_hex_ethaddr_to_binary(ascii_hex_eth, ethaddr);

			sprintf(str, "Initializing with eth addr: %02x:%02x:%02x:%02x:%02x:%02x:",
				ethaddr[0], ethaddr[1], ethaddr[2], ethaddr[3], ethaddr[4], ethaddr[5]);
			write_event(str);

			sockinit.dhcp_client = (IsDlgButtonChecked(hDlg, IDC_CHECK_DHCP) == BST_CHECKED) ? 1: 0;

			if (sockinit.dhcp_client)
				strcpy(source_ipaddr, "0.0.0.0");

			strcpy(gw_ipaddr, "0.0.0.0");
			strcpy(mask, "255.255.255.0");

			sockinit.source_ip_str = source_ipaddr;
			sockinit.gateway_ip_str = gw_ipaddr;
			sockinit.network_mask = mask;
			sockinit.dns_server_ip_str = dns_ipaddr;
			
			sockinit.local_eth = ethaddr;
			sockinit.timer_start_fn = sock_timer_start;
			sockinit.timer_stop_fn = sock_timer_stop;
			sockinit.drv_tx_fn = sock_drv_tx_fn;
			sockinit.log_fn = write_event;
			sockinit.get_ticks_fn = hs_sock_get_ticks;
			sockinit.seed = (unsigned long)GetTickCount();
			sockinit.get_rand32 = hs_sock_get_rand32;
			sockinit.global_ev_fn = hs_sock_global_event;
			
			rc = HsSockInit(&sockinit);
			if (rc != HS_SOCK_RC_OK)
			{
				sprintf(str, "HsSockInit failed, rc=%s", HsSockGetRcString(rc));
				write_event(str);
				break;
			}
	
			/* Jump to the selected adapter */
			for(d=alldevs, i=0; i< inum ;d=d->next, i++);

			if ((adhandle= pcap_open_live(d->name,	// name of the device
							 65536,					// portion of the packet to capture. 
													// 65536 grants that the whole packet will be captured on all the MACs.
							 1,						// promiscuous mode (nonzero means promiscuous)
							 1,					// read timeout
							 errbuf					// error buffer
							 )) == NULL)
			{
				sprintf(str,"Unable to open the adapter : not supported by WinPcap");
				write_event(str);
				break;
			}
			
			write_event("HsSock initialized OK");
			break;			

		case IDC_BUTTON_SHUT:
			DestroyWindow(hwnd_main);
			break;

		case IDC_BUTTON_LIS:
			start_listen(hDlg);
			break;

		case IDC_BUTTON_ADD:
			add_session(hDlg);
			break;

		case IDC_BUTTON_SEND:
			send_buffer(hDlg);
			break;

		case IDC_BUTTON_CLOSE:
			close_session(hDlg);
			break;
		}
		break;
	}
    return result;
}

/*
 * Main window message handler
 */
LRESULT CALLBACK WndProc(HWND		hWnd, 
						 UINT		message, 
						 WPARAM		wParam, 
						 LPARAM		lParam)
{
	static INITCOMMONCONTROLSEX icex;

	switch (message) 
	{
	case WM_CREATE:
		icex.dwSize = sizeof(icex);
		icex.dwICC = ICC_DATE_CLASSES;

		InitCommonControlsEx(&icex);

		InitCommonControls(); 

		dlg_main = NewDialogWin(hInst, hWnd, DlgWin, IDD_DIALOG_MAIN);
		break;

	case WM_APP_TIMER:
		process_timer(lParam);
		break;

	case WM_DESTROY:
		if (hbrush1)
		{
			SelectObject(GetWindowDC(hWnd), hbrush1);
			DeleteObject(hbrush1);
		}

		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
   
	return 0;
}

/*
 * Init Application Instance
 */
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow, HWND *hwnd)
{
	HWND hWnd;

	hInst = hInstance;

	hWnd = CreateWindow(szWindowClass, 
					   szTitle, 
					   WS_OVERLAPPED | WS_SYSMENU,
					   0, 
					   0, 
					   MAINWIDTH,
					   MAINDEPTH, 
					   NULL, LoadMenu(hInstance, (LPCTSTR)IDR_MENU1), 
					   hInstance, NULL);

	if (!hWnd)
	{
		return FALSE;
	}
	*hwnd = hWnd;

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return TRUE;
}

/*
 * entry point
 */
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG		msg;
	HACCEL	hAccelTable;
	MMRESULT res;
	int r;
	unsigned char *pkt_data;
	struct pcap_pkthdr *header;

	res = timeGetDevCaps(&timecaps, sizeof (TIMECAPS));
	if (res == TIMERR_NOERROR)
	{			
		timeBeginPeriod((UINT)timecaps.wPeriodMin);
	}
			
	hbrush1 = CreateSolidBrush(RGB(255, 255, 255));

	BlRegisterClass(hInstance, CS_HREDRAW | CS_VREDRAW, WndProc, (int)IDC_ARROW,
				   (HBRUSH)(COLOR_APPWORKSPACE+1), szWindowClass, IDI_ICON2, IDR_MENU1);

	if (!InitInstance (hInstance, nCmdShow, &hwnd_main)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)0);

	while (1) 
	{
		if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if (GetMessage(&msg, NULL, 0, 0))
			{
				if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
			else
			{
				break;
			}
		}
		else
		{
			Sleep(1);

			if (adhandle)
			{
				r = pcap_next_ex( adhandle, &header, &pkt_data);
				if (r > 0)
				{
					HsIpReceivePacket(pkt_data, (int)header->caplen);
				}
			}
			
		}		
	}

	HsSockCleanUp();

	if (alldevs)
		pcap_freealldevs(alldevs);

	if (adhandle)
		pcap_close(adhandle);
	
	return msg.wParam;	
}

